class DegreeDistribution:
    """Calculates a degree distribution for a network"""

    def __init__(self, network):
        """
        Inits DegreeDistribution with a network and calculate its distribution
        """

        # create a list to store the observations for each degree
        self.histogram = (network.maxDegree() + 1) * [0.0]
        
        # increase corresponding degrees
        for node in network.nodes.values():
            self.histogram[node.degree()] += 1.0

        # normalize with amount of nodes in network
        self.normalized = [x / float(network.size()) for x in self.histogram]
    
    def getNormalizedDistribution(self):
        '''
        Returns the computed normalized distribution
        '''
        return self.normalized