import math
import random

class Layout:
	def __init__(self, network):
		"""Layout the given network"""
		self.network = network
		
		# coulomb coefficient
		self.epsilon = 1.0
		# friction coefficient
		self.alpha = 0.03
		# random force interval
		self.interval = 0.3
		# initial square to distribute nodes
		self.size = 50
		
	def initPositions(self):
		"""
		Initialize the positions (random, think about it) and forces of all network nodes to init/reset state of the calculations
		"""
		...
		
	def calculateForces(self):
		"""
		Calculate coulomb + harmonic forces
		"""
		...
		
	def addRandomForces(self, interval):
		"""
		Add a random force to the node force within [-interval,interval]
		"""
		...
		
	def calculateEnergy(self):
	    """
		Calculate coulomb + harmonic energy
		"""
		...

		
	def displaceNodes(self, factor):
		"""
		Displace nodes according to force with a given prefactor, 
		then reset force
		"""
		...
		
	def layout(self, iterations):
		"""
		Layout network algorithm
		"""
		self.initPositions()
		energies = []
		for _ in range(iterations):
			self.calculateForces()
			self.displaceNodes(self.alpha)
			energies.append(self.calculateEnergy())
		
		return energies
	
	def SAlayout(self, iterations):
		"""
		Layout network algorithm using simulated annealing
		"""
		self.initPositions()
		energies = []
		for i in range(iterations):
			temperature = ...
			self.calculateForces()
			self.addRandomForces(self.interval * temperature)
			self.displaceNodes(self.alpha)
			energies.append(self.calculateEnergy())
			
		return energies		