import random
from AbstractNetwork import AbstractNetwork
from Node import Node

class RandomNetwork(AbstractNetwork):
    """Random network implementation of AbstractNetwork"""
    
    def __createNetwork__(self, amount_nodes, amount_links):
        """
        Creates a random network
        1. Build a list of n nodes
        2. For i=#links steps, add a connection between for two randomly chosen nodes that are not yet connected
        """
        random.seed()

        # create nodes and add to network
        for i in range(amount_nodes):
            node = Node(i)
            self.appendNode(node)

        # initialize remaining links to set
        i = amount_links
        
        # until all links are set...
        while (i > 0):
            # ...pick two nodes
            v1 = self.getNode(random.randint(0, amount_nodes-1))
            v2 = self.getNode(random.randint(0, amount_nodes-1))
            # if they are different...
            if (v1 != v2):
                # check that the link does not already exist
                if (~v1.hasLinkTo(v2) & ~v2.hasLinkTo(v1)):
                    # add links two both nodes (since we're assuming an undirected graph)
                    v1.addLinkTo(v2)
                    v2.addLinkTo(v1)
                    # decrease remaining links to set
                    i -= 1
                    